# nfc

## Lancement de l'application

### configuration de google sheets

- Ajout d'un fichier `config.dart` dans le dossier `lib` avec le contenu suivant :

```dart
class AppConfig {
  static const String apiKey = 'Votre clé d api';
  static const String sheetName = 'Nom de votre sheet name';
}
```

#### Récupération de la clé d'api :

- Accédez à la Console Google Cloud Platform, Dans le panneau de navigation à gauche, cliquez sur "API & Services + ACTIVER LES API ET LES SERVICES".
- Recherchez et sélectionnez "Google Sheets API" dans la liste des API disponibles.
- Cliquez sur le bouton "Activer" pour activer l'API pour votre projet.
- Cliquez sur "Créer des identifiants" et sélectionnez "Clé API". 
- Copiez la clé API générée.

#### Autorisation de lecture et d'écriture :

- Autorisez la lecture et l'écriture de votre feuille de calcul sur Google Sheets.

#### Récupération du sheet name :

- Ouvrez votre document Google Sheets.
- Regardez le bas de la fenêtre du navigateur où les feuilles de calcul sont répertoriées. Vous verrez les onglets pour chaque feuille de calcul dans votre document.

#### Intégration de Google Sheets dans l'application pour modification de la feuille (Ajout d'étudiant)

- Partie 1: Configurer Google Apps Script

1. Créer un Nouveau Script Google Apps
2. Donnez un nom à votre projet

   - Écrire le Script pour Manipuler Google Sheets
   Dans l'éditeur de script, remplacez le contenu du fichier Code.gs par le script suivant :

```gs
    function doPost(e) {
      var sheetId = 'VOTRE_ID_DE_FEUILLE'; // Remplacez par l'ID de votre Google Sheet
      var sheetName = 'Feuille 1'; // Ou le nom de votre feuille
      var sheet = SpreadsheetApp.openById(sheetId).getSheetByName(sheetName);
      var data = JSON.parse(e.postData.contents);
      sheet.appendRow(data.values[0]);
      return ContentService.createTextOutput(JSON.stringify({"status": "success"}))
        .setMimeType(ContentService.MimeType.JSON);
    }
    
    function doGet() {
      return ContentService.createTextOutput('La Web App est en fonctionnement.');
    }
```

- Déployer en tant que Web App

  - Cliquez sur Déployer > Nouveau déploiement.
  - Cliquez sur Sélectionner le type et choisissez Web application.
  - Entrez une description pour votre déploiement, configurez les options de partage comme désiré, et cliquez sur Déployer.
  - Copiez l'URL de la Web App qui vous est fournie pour la requete post de mise à jour de la "sheet".


### Build avec un env Linux:

```shell
flutter build linux
```

### Build avec un env android:

```shell
flutter build apk
```

### Application

#### Affichage des données

![Affichage des données](assets/images/affichage.png)

#### Génération de PDF

![Génération de PDF](assets/images/pdf.png)
